/* --------------------------------------------------------------- */
/* ファイルインクルード */
/* --------------------------------------------------------------- */
#include <stdio.h>
//#include <stdlib.h>  // rand()
//#include <string.h>  // memcpy()
//#include <unistd.h>  // usleep()

#include <wiringPi.h>

#include "CommonDefine.h"
#include "PortDefine.h"
#include "CLedColor.h"

//#define USEC_STABILIZE  (5)

/* --------------------------------------------------------------- */
/* メンバ関数定義 */
/* --------------------------------------------------------------- */

/* *************************************************************** */
/* 関数名: CLedColor */
/* 概要: コンストラクタ */
/* 引数: なし */
/* 戻り値: なし */
/* 説明: 初期設定を行なう */
/* *************************************************************** */
CLedColor::CLedColor()
{
    /* 処理なし */
    return;
}

/* *************************************************************** */
/* 関数名: ~CLedColor */
/* 概要: デストラクタ */
/* 引数: なし */
/* 戻り値: なし */
/* 説明: 後始末を行なう */
/* *************************************************************** */
CLedColor::~CLedColor()
{
    /* 処理なし */
    return;
}

/* *************************************************************** */
/* 関数名: initDevice */
/* 概要: GPIO初期化 */
/* 引数: [in] bInitGpio: wiringPiSetupを行なうか否か */
/* 戻り値: なし */
/* 説明: GPIOの設定を行なう */
/* *************************************************************** */
int CLedColor::initDevice(bool bInitGpio)
{
    /* 局所変数宣言 */
    int iRet;

    /* GPIOの初期化 */
    if (true == bInitGpio) {
        iRet = wiringPiSetup();

        if (-1 == iRet) {
            return RET_FAILED;
        }
    }

    /* GPIOの入出力設定 */
    pinMode(P_CL_RED, OUTPUT);
    pinMode(P_CL_GRN, OUTPUT);
    pinMode(P_CL_BLE, OUTPUT);

    //voClearAll();

    return RET_SUCCESS;
}

/* *************************************************************** */
/* 関数名: lightColor */
/* 概要: GPIO初期化 */
/* 引数: [in] bInitGpio: wiringPiSetupを行なうか否か */
/* 戻り値: なし */
/* 説明: GPIOの設定を行なう */
/* *************************************************************** */
int CLedColor::lightColor(enColor_t enColor)
{
    /* 局所変数宣言 */
    int iRet;

    if ((COL_BASE < enColor) && (COL_LAST > enColor)) {
        switch (enColor) {
            case COL_RED:
                digitalWrite(P_CL_RED, 1);
                digitalWrite(P_CL_GRN, 0);
                digitalWrite(P_CL_BLE, 0);
                break;
            case COL_GRN:
                digitalWrite(P_CL_RED, 0);
                digitalWrite(P_CL_GRN, 1);
                digitalWrite(P_CL_BLE, 0);
                break;
            case COL_BLE:
                digitalWrite(P_CL_RED, 0);
                digitalWrite(P_CL_GRN, 0);
                digitalWrite(P_CL_BLE, 1);
                break;
            case COL_YLW:
                digitalWrite(P_CL_RED, 1);
                digitalWrite(P_CL_GRN, 1);
                digitalWrite(P_CL_BLE, 0);
                break;
            case COL_WHT:
                digitalWrite(P_CL_RED, 1);
                digitalWrite(P_CL_GRN, 1);
                digitalWrite(P_CL_BLE, 1);
                break;
            case COL_BLK:
                /* fall through */
            default:
                digitalWrite(P_CL_RED, 0);
                digitalWrite(P_CL_GRN, 0);
                digitalWrite(P_CL_BLE, 0);
                break;
        }
        return RET_SUCCESS;
    }
    else {
        return RET_FAILED;
    }
}
