/**
 * @file Event.cpp
 * @brief CxgǗ
 * @author Naoki Okayama
 * @date 2017/06/28
 */
#include "iostream"
#include "MotorController.h"
#include "CLedColor.h"
#include "CSensorColor.h"
#include "Controller.h"
#include "CSwitchPhy.h"
#include "Event.h"

//////////////////////////////////////////////////////////
// public
//////////////////////////////////////////////////////////
/**
 * @brief RXgN^
 * @param -
 * @return -
 * @sa -
 */
Event::Event(Controller *controller){
  this->controller = controller;

  this->event = 0;
}

/**
 * @brief CxgXV
 * @parame -
 * @return -
 * @sa -
 */
void Event::updateEvent(){
  static float beforePosition;

  static unsigned int judgeStopCnt;
  static bool beforeStopFlag = true;

  //  static int beforeDistance;
  static enColor_t beforeColor;

  static unsigned int usr1Cnt = 0;
  static unsigned int usr2Cnt = 0;
  static unsigned int btn1Cnt = 0;
  static unsigned int btn2Cnt = 0;

  // XV
  bool stopFlag = this->controller->motorController->isStop();
  float position = this->controller->getPosition();
  //  int distance = this->controller->getDistance();
  enColor_t color = this->controller->getColor();
#ifndef __DEBUG2__
  unsigned int switchState = this->controller->getSwitchState();
  unsigned int usr1SwitchState = switchState & SW_STATE_ON_USR1;
  unsigned int usr2SwitchState = switchState & SW_STATE_ON_USR2;
  unsigned int btn1SwitchState = switchState & SW_STATE_ON_BTN1;
  unsigned int btn2SwitchState = switchState & SW_STATE_ON_BTN2;
#endif

  //Cxg

  // E_CHANGE_POSITIONCxg
  if(position != beforePosition){
    this->event |= E_CHANGE_POSITION;
  }else{
    this->event &= ~E_CHANGE_POSITION;
  }

  // E_STOPCxg
  if((stopFlag == true) && (beforeStopFlag == false)){
    this->event |= E_STOP;
  }else{
    this->event &= ~E_STOP;
  }
#if 0
  // E_CHANGE_DISTANCECxg
  if(distance != beforeDistance){
    this->event |= E_CHANGE_DISTANCE;
  }else{
    this->event &= ~E_CHANGE_DISTANCE;
  }
#endif
  // E_CHANGE_COLORCxg
  if(color != beforeColor){
    this->event |= E_CHANGE_COLOR;
  }else{
    this->event &= ~E_CHANGE_COLOR;
  }

  // E_RECEIVE_DEAL
  if(this->controller->getMessage() == JUDGE_DEAL){
    this->event |= E_RECEIVE_DEAL;
  }else{
    this->event &= ~E_RECEIVE_DEAL;
  }

  // E_RECEIVE_SENSE_OK
  if(this->controller->getMessage() == JUDGE_OK){
    this->event |= E_RECEIVE_SENSE_OK;
  }else{
    this->event &= ~E_RECEIVE_SENSE_OK;
  }

  // E_RECEIVE_SENSE_NG
  if(this->controller->getMessage() == JUDGE_NG){
    this->event |= E_RECEIVE_SENSE_NG;
  }else{
    this->event &= ~E_RECEIVE_SENSE_NG;
  }

  // E_RECEIVE_SENSE_TIMEOUT
  if(this->controller->getMessage() == JUDGE_TIMEOUT){
    this->event |= E_RECEIVE_SENSE_TIMEOUT;
  }else{
    this->event &= ~E_RECEIVE_SENSE_TIMEOUT;
  }

  // E_RECEIVE_JUDGE_ACK
  if(this->controller->getMessage() == JUDGE_ACK){
    this->event |= E_RECEIVE_JUDGE_ACK;
  }else{
    this->event &= ~E_RECEIVE_JUDGE_ACK;
  }

  // E_RECEIVE_JUDGE_NACK
  if(this->controller->getMessage() == JUDGE_NACK){
    this->event |= E_RECEIVE_JUDGE_NACK;
  }else{
    this->event &= ~E_RECEIVE_JUDGE_NACK;
  }
  
#ifndef __DEBUG2__
  // E_USR1_ON
  if(usr1SwitchState != 0){
    if(usr1Cnt < 2){
      usr1Cnt++;
    }else{
      this->event |= E_USR1_ON;
    }
  }else{
    usr1Cnt = 0;
    this->event &= ~E_USR1_ON;
  }

  // E_USR2_ON
  if(usr2SwitchState != 0){
    if(usr2Cnt < 2){
      usr2Cnt++;
    }else{
      this->event |= E_USR2_ON;
    }
  }else{
    usr2Cnt = 0;
    this->event &= ~E_USR2_ON;
  }

  // E_BTN1_ON
  if(btn1SwitchState != 0){
    if(btn1Cnt < 2){
      btn1Cnt++;
    }else{
      this->event |= E_BTN1_ON;
    }
  }else{
    btn1Cnt = 0;
    this->event &= ~E_BTN1_ON;
  }

  // E_BTN2_ON
  if(btn2SwitchState != 0){
    if(btn2Cnt < 2){
      btn2Cnt++;
    }else{
      this->event |= E_BTN2_ON;
    }
  }else{
    btn2Cnt = 0;
    this->event &= ~E_BTN2_ON;
  }
#endif
  
  beforeStopFlag = stopFlag;
  beforePosition = position;
  //  beforeDistance = distance;
  beforeColor = color;
}

/**
 * @brief Cxg擾
 * @parame -
 * @return Cxg
 * @sa -
 */
unsigned long Event::getEvent(){
  return this->event;
}
