/**
 * @file MotorController.h
 * @brief ステッピングモータ制御
 * @author Naoki Okayama
 * @date 2017/05/31
 */
#ifndef __MOTOR_CONTROLLER_H__
#define __MOTOR_CONTROLLER_H__

#define MAX_SPEED ((float)60)     /*!< 最大回転速度[rps] */

#if 1
#define RET_SUCCESS  (0)                    // 戻り値: 成功
#define RET_FAILED   (-1)                   // 戻り値: 失敗
#endif

class MotorController{
public:
  bool gpioEnabled;       /*!< gpio許可フラグ */
  float angle;            /*!< 回転角度[deg] */

  MotorController(void);
  ~MotorController(void);

  int initMotorController(bool bInitGpio);

  void movePosition(float xRef);
  bool isStop(void);

  float getPosition(void);

private:
  float iClause;
  bool stopFlag;

  void driveSpeed(float speed);
};

#endif
