﻿#ifndef __PORT_DEFINE_H__
#define __PORT_DEFINE_H__


/* Player側のGPIOポート定義 */
#ifdef _ENV_PLAYER_

/* for Stepping Motor */
#define P_MO_DIR    (0)     // PHY 11
#define P_MO_STEP   (1)     // PHY 12
#define P_MO_SLEEP  (2)     // PHY 13

/* for 7segment LEDs */
#define P_7S_SDA    (12)    // PHY 19
#define P_7S_SCL    (14)    // PHY 23
#define P_7S_LT1    (10)    // PHY 24
#define P_7S_LT2    (11)    // PHY 26

/* for Full color LED */
#define P_CL_RED    (3)     // PHY 15
#define P_CL_GRN    (4)     // PHY 16
#define P_CL_BLE    (5)     // PHY 18

/* for Utilities */
#define P_UT_BTN1   (13)    // PHY 21
#define P_UT_BTN2   (6)     // PHY 22
#define P_UT_USR1   (24)    // PHY 35
#define P_UT_USR2   (27)    // PHY 36
#define P_UT_EMR1   (25)    // PHY 37
#define P_UT_EMR2   (28)    // PHY 38


#endif /* _ENV_PLAYER_ */


/* Judge側のGPIOポート定義 */
#ifdef _ENV_JUDGE_

/* for Color LEDs */
#define P_CL_SDA    (1)     // PHY 12

/* for Timer */
#define P_TM_XA     (0)     // PHY 11
#define P_TM_XB     (2)     // PHY 13
#define P_TM_XC     (3)     // PHY 15
#define P_TM_XD     (4)     // PHY 16
#define P_TM_DP     (7)     // PHY 7
#define P_TM_S1     (24)    // PHY 35
#define P_TM_S2     (27)    // PHY 36
#define P_TM_S3     (25)    // PHY 37
#define P_TM_S4     (28)    // PHY 38

/* for 7segment LEDs */
#define P_7S_SDA    (12)    // PHY 19
#define P_7S_SCK    (14)    // PHY 23
#define P_7S_LT1    (10)    // PHY 24
#define P_7S_LT2    (11)    // PHY 26
#define P_7S_LT3    (21)    // PHY 29
#define P_7S_LT4    (22)    // PHY 31
#define P_7S_LT5    (26)    // PHY 32
#define P_7S_LT6    (23)    // PHY 33

/* for Utilities */
#define P_UT_BTN1   (13)    // PHY 21
#define P_UT_BTN2   (6)     // PHY 22

#endif /* _ENV_JUDGE_ */


#endif /* __PORT_DEFINE_H__ */
