#include <iostream>
#include <wiringPi.h>
#include <sys/time.h>
#include "MotorController/MotorController.h"
#include "Controller/Controller.h"
#include "Event/Event.h"
#include "LEDSlider.h"

unsigned long getTime(void);

int main(void){
    char in;

    unsigned long now;
    unsigned long old;

    Controller *controller;
    Event *event;

    LEDSlider *lEDSlider;

    float n;

    controller = new Controller();


    if(controller->initController() == RET_FAILED){
        std::cout << "[ERR] initial" << std::endl;
        delete controller;
        return -1;
    }
    event = new Event(controller);

    lEDSlider = new LEDSlider(controller);

    now = 60000.0;
    old = 0.0;

    while(true){
        while((now = getTime()) - old < 60000){
            ;
        }
        old = now;

        controller->run();
        event->updateEvent();

        lEDSlider->execState();
        lEDSlider->doTransition(event->getEvent());
    }
    delete lEDSlider;
    delete event;
    delete controller;
}


unsigned long getTime(void){
    struct timeval t;

    gettimeofday(&t, NULL);

    return ((unsigned long)t.tv_sec*1000000 + (unsigned long)t.tv_usec);
}
